--- title: "Get Rule Objects in a Domain" slug: "get-rule-objects-in-a-domain-2" tags: ["IPS 11.1.x", "Reference"] updated: 2026-11-19T12:57:44Z published: 2026-11-19T12:57:44Z canonical: "docs.trellix.com/get-rule-objects-in-a-domain-2" --- > ## Documentation Index > Fetch the complete documentation index at: https://docs.trellix.com/llms.txt > Use this file to discover all available pages before exploring further. # Get Rule Objects in a Domain This URL gets the list of rule objects defined in a particular domain. ### Resource URL GET /domain//ruleobject?type= ### Request Parameters | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `domain_id` | Domain ID | Number | Yes | | `type` | Rule object type, can be application, applicationgroup, applicationoncustomport, country, finitetimeperiod, hostdnsname, hostipv4, hostipv6, ipv4addressrange, ipv6addressrange, network ipv4, networkipv6, networkgroup, recurringtimeperiod, recurringtimeperiodgroup, service, servicerange, servicegroup | String | Yes | ### Response Parameters Following fields are returned if the request parameters are correct, otherwise error details are returned. | Field Name | Description | Data Type | | --- | --- | --- | | `ruleobjId` | Rule object ID | String | | `ruleobjType` | Rule object name | String | | `name` | Rule object type | String | | `description` | Description | String | | `domain` | ID of domain in which the rule object is defined | Number | | `visibleToChild` | Is rule object visible to child | Boolean | | `ApplicationGroup` | Application group object, should be defined if ruleobjType is "APPLICATION_GROUP" | Object | | `ApplicationOnCustomPort` | Application defined on custom port object, should be defined if ruleobjType is "APPLICATION_ON_CUSTOM_PORT" | Object | | `FiniteTimePeriod` | Finite time period object, should be defined if ruleobjType is "FINITE_TIME_PERIOD" | Object | | `HostIPv4` | Host IPv4 address object, should be defined if ruleobjType is "HOST_IPV_4" | Object | | `HostIPv6` | Host IPv6 address object, should be defined if ruleobjType is "HOST_IPV_6" | Object | | `HostDNSName` | Host DNS name object, should be defined if ruleobjType is "HOST_DNS_NAME" | Object | | `IPv4AddressRange` | IPv4 address range object, should be defined if ruleobjType is "IPV_4_ADDRESS_RANGE" | Object | | `IPv6AddressRange` | IPv6 address range object, should be defined if ruleobjType is "IPV_6_ADDRESS_RANGE" | Object | | `NetworkIPv4` | IPv4 network object, should be defined if ruleobjType is "NETWORK_IPV_4" | Object | | `NetworkIPv6` | IPv6 network object, should be defined if ruleobjType is "NETWORK_IPV_6" | Object | | `NetworkGroup` | Network group object, should be defined if ruleobjType is "NETWORK_GROUP" | Object | | `RecurringTimePeriod` | Recurring time period object, should be defined if ruleobjType is "RECURRING_TIME_PERIOD" | Object | | `RecurringTimePeriodGroup` | Recurring time period group object, should be defined if ruleobjType is "RECURRING_TIME_PERIOD_GROUP" | Object | | `Service` | Service object, should be defined if ruleobjType is "CUSTOM_SERVICE" | Object | | `ServiceRange` | Service range object, should be defined if ruleobjType is "SERVICE_RANGE" | Object | | `ServiceGroup` | Service group object, should be defined if ruleobjType is "SERVICE_GROUP" | Object | Details of ApplicationGroup | Field Name | Description | Data Type | | --- | --- | --- | | `ApplicationIdentifier` | List of applications identifier | Array | Details of object in ApplicationIdentifier: | Field Name | Description | Data Type | | --- | --- | --- | | `applicationRuleObjId` | Application rule object ID | String | | `applicationType` | Application type, can be "DEFAULT_APPLICATION" / "APPLICATION_ON_CUSTOM_PORT" | String | Details of ApplicationonCustomPort | Field Name | Description | Data Type | | --- | --- | --- | | `applicationId` | Application ID | String | | `portsList` | List of ports | Array | Details of object in portsList: | Field Name | Description | Data Type | | --- | --- | --- | | `IPProtocol` | IP protocol, can be "TCP" / "UDP" | String | | `port` | Port | Number | Details of FiniteTimePeriod: | Field Name | Description | Data Type | | --- | --- | --- | | `from` | From time | String | | `until` | To time | String | Details of HostIPv4: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `hostIPv4AddressList` | List of IPv4 host address | Object | Yes | Details of hostIPv4AddressList: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `ruleObjID` | Rule object ID | Number | Yes | | `state` | State of the rule member, should be 1 to Enable and 0 to Disable the rule member. | Number | Yes | | `comment` | User comment | String | No | | `userID` | User ID | Number | Yes | | `value` | IPv4 Address | String | Yes | | `changedState` | Change the state of a rule member, should be 1 to add, 2 to update and 3 to delete a rule member. | Number | Yes | Details of HostIPv6: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `hostIPv6AddressList` | List of IPv6 host address | Object | Yes | Details of hostIPv6AddressList: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `ruleObjID` | Rule object ID | Number | Yes | | `state` | State of the rule member, should be 1 to Enable and 0 to Disable the rule member. | Number | Yes | | `comment` | User comment | String | No | | `userID` | User ID | Number | Yes | | `value` | IPv6 Address | String | Yes | | `changedState` | Change the state of a rule member, should be 1 to add, 2 to update and 3 to delete a rule member. | Number | Yes | Details of HostDNSName | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `hostDNSNameList` | List of host DNS names | Object | Yes | Details of hostDNSNameList: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `ruleObjID` | Rule object ID | Number | Yes | | `state` | State of the rule member, should be 1 to Enable and 0 to Disable the rule member. | Number | Yes | | `comment` | User comment | String | No | | `userID` | User ID | Number | Yes | | `value` | host DNS name | String | Yes | | `changedState` | Change the state of a rule member, should be 1 to add, 2 to update and 3 to delete a rule member. | Number | Yes | Details of IPv4AddressRange: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `IPV4RangeList` | List of IPv4 address range | Object | Yes | Details of IPV4RangeList: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `ruleObjID` | Rule object ID | Number | Yes | | `state` | State of the rule member, should be 1 to Enable and 0 to Disable the rule member. | Number | Yes | | `comment` | User comment | String | No | | `userID` | User ID | Number | Yes | | `FromAddress` | Start IP range | String | Yes | | `ToAddress` | End IP range | String | Yes | | `changedState` | Change the state of a rule member, should be 1 to add, 2 to update and 3 to delete a rule member. | Number | Yes | Details of IPv6AddressRange: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `IPV6RangeList` | List of IPv6 address range | Object | Yes | Details of IPV6RangeList: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `ruleObjID` | Rule object ID | Number | Yes | | `state` | State of the rule member, should be 1 to Enable and 0 to Disable the rule member. | Number | Yes | | `comment` | User comment | String | No | | `userID` | User ID | Number | Yes | | `FromAddress` | Start IPv6 range | String | Yes | | `ToAddress` | End IPv6 range | String | Yes | | `changedState` | Change the state of a rule member, should be 1 to add, 2 to update and 3 to delete a rule member. | Number | Yes | Details of NetworkIPv4: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `networkIPV4List` | List of network IPv4 addresses | Object | Yes | Details of networkIPV4List: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `ruleObjID` | Rule object ID | Number | Yes | | `state` | State of the rule member, should be 1 to Enable and 0 to Disable the rule member. | Number | Yes | | `comment` | User comment | String | No | | `userID` | User ID | Number | Yes | | `value` | IPv4 network | String | Yes | | `changedState` | Change the state of a rule member, should be 1 to add, 2 to update and 3 to delete a rule member. | Number | Yes | Details of NetworkIPv6: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `networkIPV6List` | List of network IPv6 addresses | Object | Yes | Details of networkIPV6List: | Field Name | Description | Data Type | Mandatory | | --- | --- | --- | --- | | `ruleObjID` | Rule object ID | Number | Yes | | `state` | State of the rule member, should be 1 to Enable and 0 to Disable the rule member. | Number | Yes | | `comment` | User comment | String | No | | `userID` | User ID | Number | Yes | | `value` | IPv6 network | String | Yes | | `changedState` | Change the state of a rule member, should be 1 to add, 2 to update and 3 to delete a rule member. | Number | Yes | Details of NetworkGroup | Field Name | Description | Data Type | | --- | --- | --- | | `NetworkGroupIdentifier` | List of network objects | Array | Details of object in NetworkGroupIdentifier: | Field Name | Description | Data Type | | --- | --- | --- | | `RuleObjId` | Network rule object ID | String | | `type` | Network type, can be "COUNTRY" / "HOST_IPV_4" / "HOST_IPV_6" / "HOST_DNS_NAME" / "IPV_4_ADDRESS_RANGE" / "IPV_6_ADDRESS_RANGE" / "NETWORK_IPV_4" / "NETWORK_IPV_6" | String | Details of RecurringTimePeriod: | Field Name | Description | Data Type | | --- | --- | --- | | `entireDay` | Entire day object | Boolean | | `duration` | Duration object | Object | | `day` | List of days, can be "MONDAY", "TUESDAY", "WEDNESDAY", "THURSDAY", "FRIDAY", "SATURDAY", "SUNDAY" | String | Details of object in duration: | Field Name | Description | Data Type | | --- | --- | --- | | `from` | From time | String | | `until` | To time | String | Details of RecurringTimePeriodGroup: | Field Name | Description | Data Type | | --- | --- | --- | | `recurringTimePeriodsId` | List of recurring time period rule object Id's | Array | Details of Service: | Field Name | Description | Data Type | | --- | --- | --- | | `protocol` | Protocol, can be "TCP" / "UDP" / "PROTOCOL_NUMBER" | String | | `portNumber` | Port number | String | Details of ServiceRange: | Field Name | Description | Data Type | | --- | --- | --- | | protocol | Protocol, can be "TCP" / "UDP" / "PROTOCOL_NUMBER" | String | | From | From port/protocol number | String | | To | To port/protocol number | String | Details of ServiceGroup: | Field Name | Description | Data Type | | --- | --- | --- | | `ServiceIdentifier` | List of service objects | Array | Details of object in ServiceIdentifier: | Field Name | Description | Data Type | | --- | --- | --- | | `ServiceRuleObjId` | Service rule object ID | String | | `ServiceType` | Service type, can be "DEFAULT_SERVICE" / "CUSTOM_SERVICE" | String | ### Example **Request** GET [https:///sdkapi/domain/0/ruleobject?type= Application,ApplicationGroup,ApplicationOnCustomPort,Country,FiniteTimePeriod,HostDNSName,HostIpv4,IPV4AddressRange,Network,NetworkGroup,RecurringTimePeriod,RecurringTimePeriodGroup,Service,ServiceGroup](https://<NSM_IP>/sdkapi/domain/0/ruleobject?type=%20Application,ApplicationGroup,ApplicationOnCustomPort,Country,FiniteTimePeriod,HostDNSName,HostIpv4,IPV4AddressRange,Network,NetworkGroup,RecurringTimePeriod,RecurringTimePeriodGroup,Service,ServiceGroup) **Response** ``` {    "RuleObjDef": [        {            "ruleobjId": "234",            "ruleobjType": "HOST_IPV_4",            "name": "test_SDK3",            "description": "try",            "domain": 0,            "visibleToChild": true,            "hostCriticality": "HIGH",            "ApplicationGroup": null,            "ApplicationOnCustomPort": null,            "FiniteTimePeriod": null,            "HostIPv4": {                "hostIPv4AddressList": [                    {                        "ruleObjectID": 234,                        "value": "172.1.1.3",                        "state": 1,                        "comment": "test",                        "userID": 0,                        "changedState": 0                    },                    {                        "ruleObjectID": 234,                        "value": "172.9.0.2",                        "state": 1,                        "comment": "test",                        "userID": 0,                        "changedState": 0                    }                ]            },            "HostIPv6": null,            "HostDNSName": null,            "IPv4AddressRange": null,            "IPv6AddressRange": null,            "Network_IPV_4": null,            "Network_IPV_6": null,            "NetworkGroup": null,            "RecurringTimePeriod": null,            "RecurringTimePeriodGroup": null,            "Service": null,            "ServiceGroup": null,            "ServiceRange": null        },        {            "ruleobjId": "233",            "ruleobjType": "HOST_IPV_4",            "name": "imp",            "description": "",            "domain": 0,            "visibleToChild": true,            "hostCriticality": "LOW",            "ApplicationGroup": null,            "ApplicationOnCustomPort": null,            "FiniteTimePeriod": null,            "HostIPv4": {                "hostIPv4AddressList": [                    {                        "ruleObjectID": 233,                        "value": "5.2.72.22",                        "state": 1,                        "comment": "Testing purpose",                        "userID": 1,                        "changedState": 0                    },                    {                        "ruleObjectID": 233,                        "value": "10.1.1.9",                        "state": 1,                        "comment": " test 9",                        "userID": 1,                        "changedState": 0                    }                ]            },            "HostIPv6": null,            "HostDNSName": null,            "IPv4AddressRange": null,            "IPv6AddressRange": null,            "Network_IPV_4": null,            "Network_IPV_6": null,            "NetworkGroup": null,            "RecurringTimePeriod": null,            "RecurringTimePeriodGroup": null,            "Service": null,            "ServiceGroup": null,            "ServiceRange": null        }    ] } ``` ### Error Information Following error codes are returned by this URL: | S.No | HTTP Error Code | SDK API errorId | SDK API errorMessage | | --- | --- | --- | --- | | 1 | 404 | 1105 | Invalid domain | | 2 | 404 | 1702 | Invalid rule object type | | 3 | 404 | 1704 | Rule object type is expected |